/* Generated By:JavaCC: Do not edit this line. HeaderValue.java */
package org.jboss.osgi.plugins.metadata;

import java.io.StringReader;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.jboss.osgi.spi.metadata.*;

/**
 * A JavaCC 3.2 grammar for the OSGi R4 bundle headers
 *
 * @author Scott.Stark@jboss.org
 * @author Ales.Justin@jboss.org
 */
public class HeaderValue implements HeaderValueConstants {
   public HeaderValue()
   {
      this(new StringReader(""));
   }

   public HeaderValue(String value)
   {
      this(new StringReader(value));
   }

   private void applyTracing(boolean trace)
   {
      if (trace)
      {
         enable_tracing();
      }
      else
      {
         disable_tracing();
      }
   }

   private void addParameter(Map<String, Parameter> parameters, String key, String value)
   {
      Parameter parameter = parameters.get(key);
      if (parameter == null)
      {
         parameter = new AbstractParameter();
         parameters.put(key, parameter);
      }
      parameter.addValue(value);
   }

   public void parsePackages(List<PackageAttribute> list, boolean trace)
      throws ParseException
   {
      // This will have no effect unless the debugging options are true
      applyTracing(trace);
      parsePackages(list);
   }

   public void parseParameters(List<ParameterizedAttribute> list, boolean trace)
      throws ParseException
   {
      // This will have no effect unless the debugging options are true
      applyTracing(trace);
      parseParameters(list);
   }

   public void parsePaths(List<ParameterizedAttribute> list, boolean trace)
      throws ParseException
   {
      // This will have no effect unless the debugging options are true
      applyTracing(trace);
      parsePaths(list);
   }

   public static void parsePackages(String header, List<PackageAttribute> list, boolean trace)
      throws ParseException
   {
      HeaderValue parser = new HeaderValue(header);
      parser.parsePackages(list, trace);
   }

   public static void parseParameters(String header, List<ParameterizedAttribute> list, boolean trace)
      throws ParseException
   {
      HeaderValue parser = new HeaderValue(header);
      parser.parseParameters(list, trace);
   }

   public static void parsePaths(String header, List<ParameterizedAttribute> list, boolean trace)
      throws ParseException
   {
      HeaderValue parser = new HeaderValue(header);
      parser.parsePaths(list, trace);
   }

/** Start of the grammar */
/** Entry point for the Import-Package header value parsing. */
  final public void parsePackages(List<PackageAttribute> list) throws ParseException {
    trace_call("parsePackages");
    try {
      packageInfo(list);
      label_1:
      while (true) {
        if (jj_2_1(2)) {
          ;
        } else {
          break label_1;
        }
        jj_consume_token(24);
        packageInfo(list);
      }

    } finally {
      trace_return("parsePackages");
    }
  }

  final public void parseParameters(List<ParameterizedAttribute> list) throws ParseException {
    trace_call("parseParameters");
    try {
      parameterInfo(list);
      label_2:
      while (true) {
        if (jj_2_2(2)) {
          ;
        } else {
          break label_2;
        }
        jj_consume_token(24);
        parameterInfo(list);
      }

    } finally {
      trace_return("parseParameters");
    }
  }

  final public void parsePaths(List<ParameterizedAttribute> list) throws ParseException {
    trace_call("parsePaths");
    try {
      pathInfo(list);
      label_3:
      while (true) {
        if (jj_2_3(2)) {
          ;
        } else {
          break label_3;
        }
        jj_consume_token(24);
        pathInfo(list);
      }

    } finally {
      trace_return("parsePaths");
    }
  }

  final public void packageInfo(List<PackageAttribute> list) throws ParseException {
    trace_call("packageInfo");
    try {
   List<String> packages = new ArrayList<String>();
   Map<String, Parameter> parameters = new HashMap<String, Parameter>();
      packageNames(packages);
      label_4:
      while (true) {
        if (jj_2_4(2)) {
          ;
        } else {
          break label_4;
        }
        jj_consume_token(25);
        parsePackageParameters(parameters);
      }
      for(String pckg : packages)
      {
         list.add(new AbstractPackageAttribute(pckg, parameters));
      }
    } finally {
      trace_return("packageInfo");
    }
  }

  final public void pathInfo(List<ParameterizedAttribute> list) throws ParseException {
    trace_call("pathInfo");
    try {
   List<String> paths = new ArrayList<String>();
   Map<String, Parameter> parameters = new HashMap<String, Parameter>();
      pathNames(paths);
      label_5:
      while (true) {
        jj_consume_token(25);
        parsePathParameters(parameters);
        if (jj_2_5(2)) {
          ;
        } else {
          break label_5;
        }
      }
      for(String path : paths)
      {
         list.add(new AbstractPackageAttribute(path, parameters));
      }
    } finally {
      trace_return("pathInfo");
    }
  }

  final public void parameterInfo(List<ParameterizedAttribute> list) throws ParseException {
    trace_call("parameterInfo");
    try {
   Token t;
   Map<String, Parameter> parameters = new HashMap<String, Parameter>();
      t = jj_consume_token(QNAME);
      label_6:
      while (true) {
        if (jj_2_6(2)) {
          ;
        } else {
          break label_6;
        }
        jj_consume_token(25);
        parseAttributeParameters(parameters);
      }
      list.add(new AbstractParameterizedAttribute(t.toString(), parameters));
    } finally {
      trace_return("parameterInfo");
    }
  }

  final public void packageNames(List<String> packages) throws ParseException {
    trace_call("packageNames");
    try {
        Token t;
      if (jj_2_9(2)) {
        t = jj_consume_token(QNAME);
             packages.add(t.image);
        label_7:
        while (true) {
          if (jj_2_7(2)) {
            ;
          } else {
            break label_7;
          }
          jj_consume_token(25);
          packageNames(packages);
        }
      } else if (jj_2_10(2)) {
        t = jj_consume_token(STAR);
            packages.add(t.image);
        label_8:
        while (true) {
          if (jj_2_8(2)) {
            ;
          } else {
            break label_8;
          }
          jj_consume_token(25);
          packageNames(packages);
        }
      } else {
        jj_consume_token(-1);
        throw new ParseException();
      }
    } finally {
      trace_return("packageNames");
    }
  }

  final public void pathNames(List<String> paths) throws ParseException {
    trace_call("pathNames");
    try {
        Token t;
      t = jj_consume_token(PATH);
            paths.add(t.image);
      label_9:
      while (true) {
        if (jj_2_11(2)) {
          ;
        } else {
          break label_9;
        }
        jj_consume_token(25);
        pathNames(paths);
      }
    } finally {
      trace_return("pathNames");
    }
  }

  final public void parsePackageParameters(Map<String, Parameter> parameters) throws ParseException {
    trace_call("parsePackageParameters");
    try {
   Token t;
      if (jj_2_13(2)) {
        t = jj_consume_token(DIRECTIVE);
      String ts = t.toString();
      String[] params = ts.split(":=");
      addParameter(parameters, params[0], params[1]);
      } else if (jj_2_14(2)) {
        t = jj_consume_token(ATTRIBUTE);
      String ts = t.toString();
      String[] params = ts.split("=");
      addParameter(parameters, params[0], params[1]);
        label_10:
        while (true) {
          if (jj_2_12(2)) {
            ;
          } else {
            break label_10;
          }
          jj_consume_token(25);
          parsePackageParameters(parameters);
        }
      } else {
        jj_consume_token(-1);
        throw new ParseException();
      }
    } finally {
      trace_return("parsePackageParameters");
    }
  }

  final public void parseAttributeParameters(Map<String, Parameter> parameters) throws ParseException {
    trace_call("parseAttributeParameters");
    try {
   Token t;
      if (jj_2_16(2)) {
        t = jj_consume_token(DIRECTIVE);
      String ts = t.toString();
      String[] params = ts.split(":=");
      addParameter(parameters, params[0], params[1]);
      } else if (jj_2_17(2)) {
        t = jj_consume_token(ATTRIBUTE);
      String ts = t.toString();
      String[] params = ts.split("=");
      addParameter(parameters, params[0], params[1]);
        label_11:
        while (true) {
          if (jj_2_15(2)) {
            ;
          } else {
            break label_11;
          }
          jj_consume_token(25);
          parseAttributeParameters(parameters);
        }
      } else {
        jj_consume_token(-1);
        throw new ParseException();
      }
    } finally {
      trace_return("parseAttributeParameters");
    }
  }

  final public void parsePathParameters(Map<String, Parameter> parameters) throws ParseException {
    trace_call("parsePathParameters");
    try {
   Token t;
      if (jj_2_19(2)) {
        t = jj_consume_token(DIRECTIVE);
      String ts = t.toString();
      String[] params = ts.split(":=");
      addParameter(parameters, params[0], params[1]);
      } else if (jj_2_20(2)) {
        t = jj_consume_token(ATTRIBUTE);
      String ts = t.toString();
      String[] params = ts.split("=");
      addParameter(parameters, params[0], params[1]);
        label_12:
        while (true) {
          if (jj_2_18(2)) {
            ;
          } else {
            break label_12;
          }
          jj_consume_token(25);
          parsePathParameters(parameters);
        }
      } else {
        jj_consume_token(-1);
        throw new ParseException();
      }
    } finally {
      trace_return("parsePathParameters");
    }
  }

  final private boolean jj_2_1(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_1(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(0, xla); }
  }

  final private boolean jj_2_2(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_2(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(1, xla); }
  }

  final private boolean jj_2_3(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_3(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(2, xla); }
  }

  final private boolean jj_2_4(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_4(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(3, xla); }
  }

  final private boolean jj_2_5(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_5(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(4, xla); }
  }

  final private boolean jj_2_6(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_6(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(5, xla); }
  }

  final private boolean jj_2_7(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_7(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(6, xla); }
  }

  final private boolean jj_2_8(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_8(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(7, xla); }
  }

  final private boolean jj_2_9(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_9(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(8, xla); }
  }

  final private boolean jj_2_10(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_10(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(9, xla); }
  }

  final private boolean jj_2_11(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_11(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(10, xla); }
  }

  final private boolean jj_2_12(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_12(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(11, xla); }
  }

  final private boolean jj_2_13(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_13(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(12, xla); }
  }

  final private boolean jj_2_14(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_14(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(13, xla); }
  }

  final private boolean jj_2_15(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_15(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(14, xla); }
  }

  final private boolean jj_2_16(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_16(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(15, xla); }
  }

  final private boolean jj_2_17(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_17(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(16, xla); }
  }

  final private boolean jj_2_18(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_18(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(17, xla); }
  }

  final private boolean jj_2_19(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_19(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(18, xla); }
  }

  final private boolean jj_2_20(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_20(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(19, xla); }
  }

  final private boolean jj_3_5() {
    if (jj_scan_token(25)) return true;
    if (jj_3R_17()) return true;
    return false;
  }

  final private boolean jj_3R_18() {
    if (!jj_rescan) trace_call("parseAttributeParameters(LOOKING AHEAD...)");
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_16()) {
    jj_scanpos = xsp;
    if (jj_3_17()) { if (!jj_rescan) trace_return("parseAttributeParameters(LOOKAHEAD FAILED)"); return true; }
    }
    { if (!jj_rescan) trace_return("parseAttributeParameters(LOOKAHEAD SUCCEEDED)"); return false; }
  }

  final private boolean jj_3_16() {
    if (jj_scan_token(DIRECTIVE)) return true;
    return false;
  }

  final private boolean jj_3_8() {
    if (jj_scan_token(25)) return true;
    if (jj_3R_19()) return true;
    return false;
  }

  final private boolean jj_3R_14() {
    if (!jj_rescan) trace_call("parameterInfo(LOOKING AHEAD...)");
    if (jj_scan_token(QNAME)) { if (!jj_rescan) trace_return("parameterInfo(LOOKAHEAD FAILED)"); return true; }
    { if (!jj_rescan) trace_return("parameterInfo(LOOKAHEAD SUCCEEDED)"); return false; }
  }

  final private boolean jj_3_7() {
    if (jj_scan_token(25)) return true;
    if (jj_3R_19()) return true;
    return false;
  }

  final private boolean jj_3_12() {
    if (jj_scan_token(25)) return true;
    if (jj_3R_16()) return true;
    return false;
  }

  final private boolean jj_3_4() {
    if (jj_scan_token(25)) return true;
    if (jj_3R_16()) return true;
    return false;
  }

  final private boolean jj_3_18() {
    if (jj_scan_token(25)) return true;
    if (jj_3R_17()) return true;
    return false;
  }

  final private boolean jj_3_14() {
    if (jj_scan_token(ATTRIBUTE)) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_12()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  final private boolean jj_3R_15() {
    if (!jj_rescan) trace_call("pathInfo(LOOKING AHEAD...)");
    if (jj_3R_20()) { if (!jj_rescan) trace_return("pathInfo(LOOKAHEAD FAILED)"); return true; }
    { if (!jj_rescan) trace_return("pathInfo(LOOKAHEAD SUCCEEDED)"); return false; }
  }

  final private boolean jj_3_20() {
    if (jj_scan_token(ATTRIBUTE)) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_18()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  final private boolean jj_3R_16() {
    if (!jj_rescan) trace_call("parsePackageParameters(LOOKING AHEAD...)");
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_13()) {
    jj_scanpos = xsp;
    if (jj_3_14()) { if (!jj_rescan) trace_return("parsePackageParameters(LOOKAHEAD FAILED)"); return true; }
    }
    { if (!jj_rescan) trace_return("parsePackageParameters(LOOKAHEAD SUCCEEDED)"); return false; }
  }

  final private boolean jj_3_13() {
    if (jj_scan_token(DIRECTIVE)) return true;
    return false;
  }

  final private boolean jj_3R_17() {
    if (!jj_rescan) trace_call("parsePathParameters(LOOKING AHEAD...)");
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_19()) {
    jj_scanpos = xsp;
    if (jj_3_20()) { if (!jj_rescan) trace_return("parsePathParameters(LOOKAHEAD FAILED)"); return true; }
    }
    { if (!jj_rescan) trace_return("parsePathParameters(LOOKAHEAD SUCCEEDED)"); return false; }
  }

  final private boolean jj_3_19() {
    if (jj_scan_token(DIRECTIVE)) return true;
    return false;
  }

  final private boolean jj_3_3() {
    if (jj_scan_token(24)) return true;
    if (jj_3R_15()) return true;
    return false;
  }

  final private boolean jj_3R_20() {
    if (!jj_rescan) trace_call("pathNames(LOOKING AHEAD...)");
    if (jj_scan_token(PATH)) { if (!jj_rescan) trace_return("pathNames(LOOKAHEAD FAILED)"); return true; }
    { if (!jj_rescan) trace_return("pathNames(LOOKAHEAD SUCCEEDED)"); return false; }
  }

  final private boolean jj_3_2() {
    if (jj_scan_token(24)) return true;
    if (jj_3R_14()) return true;
    return false;
  }

  final private boolean jj_3_15() {
    if (jj_scan_token(25)) return true;
    if (jj_3R_18()) return true;
    return false;
  }

  final private boolean jj_3R_13() {
    if (!jj_rescan) trace_call("packageInfo(LOOKING AHEAD...)");
    if (jj_3R_19()) { if (!jj_rescan) trace_return("packageInfo(LOOKAHEAD FAILED)"); return true; }
    { if (!jj_rescan) trace_return("packageInfo(LOOKAHEAD SUCCEEDED)"); return false; }
  }

  final private boolean jj_3_6() {
    if (jj_scan_token(25)) return true;
    if (jj_3R_18()) return true;
    return false;
  }

  final private boolean jj_3_10() {
    if (jj_scan_token(STAR)) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_8()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  final private boolean jj_3R_19() {
    if (!jj_rescan) trace_call("packageNames(LOOKING AHEAD...)");
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_9()) {
    jj_scanpos = xsp;
    if (jj_3_10()) { if (!jj_rescan) trace_return("packageNames(LOOKAHEAD FAILED)"); return true; }
    }
    { if (!jj_rescan) trace_return("packageNames(LOOKAHEAD SUCCEEDED)"); return false; }
  }

  final private boolean jj_3_9() {
    if (jj_scan_token(QNAME)) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_7()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  final private boolean jj_3_17() {
    if (jj_scan_token(ATTRIBUTE)) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_15()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  final private boolean jj_3_1() {
    if (jj_scan_token(24)) return true;
    if (jj_3R_13()) return true;
    return false;
  }

  final private boolean jj_3_11() {
    if (jj_scan_token(25)) return true;
    if (jj_3R_20()) return true;
    return false;
  }

  public HeaderValueTokenManager token_source;
  SimpleCharStream jj_input_stream;
  public Token token, jj_nt;
  private int jj_ntk;
  private Token jj_scanpos, jj_lastpos;
  private int jj_la;
  public boolean lookingAhead = false;
  private boolean jj_semLA;
  private int jj_gen;
  final private int[] jj_la1 = new int[0];
  static private int[] jj_la1_0;
  static {
      jj_la1_0();
   }
   private static void jj_la1_0() {
      jj_la1_0 = new int[] {};
   }
  final private JJCalls[] jj_2_rtns = new JJCalls[20];
  private boolean jj_rescan = false;
  private int jj_gc = 0;

  public HeaderValue(java.io.InputStream stream) {
     this(stream, null);
  }
  public HeaderValue(java.io.InputStream stream, String encoding) {
    try { jj_input_stream = new SimpleCharStream(stream, encoding, 1, 1); } catch(java.io.UnsupportedEncodingException e) { throw new RuntimeException(e); }
    token_source = new HeaderValueTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 0; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public void ReInit(java.io.InputStream stream) {
     ReInit(stream, null);
  }
  public void ReInit(java.io.InputStream stream, String encoding) {
    try { jj_input_stream.ReInit(stream, encoding, 1, 1); } catch(java.io.UnsupportedEncodingException e) { throw new RuntimeException(e); }
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 0; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public HeaderValue(java.io.Reader stream) {
    jj_input_stream = new SimpleCharStream(stream, 1, 1);
    token_source = new HeaderValueTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 0; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public void ReInit(java.io.Reader stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 0; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public HeaderValue(HeaderValueTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 0; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public void ReInit(HeaderValueTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 0; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  final private Token jj_consume_token(int kind) throws ParseException {
    Token oldToken;
    if ((oldToken = token).next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    if (token.kind == kind) {
      jj_gen++;
      if (++jj_gc > 100) {
        jj_gc = 0;
        for (int i = 0; i < jj_2_rtns.length; i++) {
          JJCalls c = jj_2_rtns[i];
          while (c != null) {
            if (c.gen < jj_gen) c.first = null;
            c = c.next;
          }
        }
      }
      trace_token(token, "");
      return token;
    }
    token = oldToken;
    jj_kind = kind;
    throw generateParseException();
  }

  static private final class LookaheadSuccess extends java.lang.Error { }
  final private LookaheadSuccess jj_ls = new LookaheadSuccess();
  final private boolean jj_scan_token(int kind) {
    if (jj_scanpos == jj_lastpos) {
      jj_la--;
      if (jj_scanpos.next == null) {
        jj_lastpos = jj_scanpos = jj_scanpos.next = token_source.getNextToken();
      } else {
        jj_lastpos = jj_scanpos = jj_scanpos.next;
      }
    } else {
      jj_scanpos = jj_scanpos.next;
    }
    if (jj_rescan) {
      int i = 0; Token tok = token;
      while (tok != null && tok != jj_scanpos) { i++; tok = tok.next; }
      if (tok != null) jj_add_error_token(kind, i);
    } else {
      trace_scan(jj_scanpos, kind);
    }
    if (jj_scanpos.kind != kind) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) throw jj_ls;
    return false;
  }

  final public Token getNextToken() {
    if (token.next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    jj_gen++;
      trace_token(token, " (in getNextToken)");
    return token;
  }

  final public Token getToken(int index) {
    Token t = lookingAhead ? jj_scanpos : token;
    for (int i = 0; i < index; i++) {
      if (t.next != null) t = t.next;
      else t = t.next = token_source.getNextToken();
    }
    return t;
  }

  final private int jj_ntk() {
    if ((jj_nt=token.next) == null)
      return (jj_ntk = (token.next=token_source.getNextToken()).kind);
    else
      return (jj_ntk = jj_nt.kind);
  }

  private java.util.Vector jj_expentries = new java.util.Vector();
  private int[] jj_expentry;
  private int jj_kind = -1;
  private int[] jj_lasttokens = new int[100];
  private int jj_endpos;

  private void jj_add_error_token(int kind, int pos) {
    if (pos >= 100) return;
    if (pos == jj_endpos + 1) {
      jj_lasttokens[jj_endpos++] = kind;
    } else if (jj_endpos != 0) {
      jj_expentry = new int[jj_endpos];
      for (int i = 0; i < jj_endpos; i++) {
        jj_expentry[i] = jj_lasttokens[i];
      }
      boolean exists = false;
      for (java.util.Enumeration e = jj_expentries.elements(); e.hasMoreElements();) {
        int[] oldentry = (int[])(e.nextElement());
        if (oldentry.length == jj_expentry.length) {
          exists = true;
          for (int i = 0; i < jj_expentry.length; i++) {
            if (oldentry[i] != jj_expentry[i]) {
              exists = false;
              break;
            }
          }
          if (exists) break;
        }
      }
      if (!exists) jj_expentries.addElement(jj_expentry);
      if (pos != 0) jj_lasttokens[(jj_endpos = pos) - 1] = kind;
    }
  }

  public ParseException generateParseException() {
    jj_expentries.removeAllElements();
    boolean[] la1tokens = new boolean[26];
    for (int i = 0; i < 26; i++) {
      la1tokens[i] = false;
    }
    if (jj_kind >= 0) {
      la1tokens[jj_kind] = true;
      jj_kind = -1;
    }
    for (int i = 0; i < 0; i++) {
      if (jj_la1[i] == jj_gen) {
        for (int j = 0; j < 32; j++) {
          if ((jj_la1_0[i] & (1<<j)) != 0) {
            la1tokens[j] = true;
          }
        }
      }
    }
    for (int i = 0; i < 26; i++) {
      if (la1tokens[i]) {
        jj_expentry = new int[1];
        jj_expentry[0] = i;
        jj_expentries.addElement(jj_expentry);
      }
    }
    jj_endpos = 0;
    jj_rescan_token();
    jj_add_error_token(0, 0);
    int[][] exptokseq = new int[jj_expentries.size()][];
    for (int i = 0; i < jj_expentries.size(); i++) {
      exptokseq[i] = (int[])jj_expentries.elementAt(i);
    }
    return new ParseException(token, exptokseq, tokenImage);
  }

  private int trace_indent = 0;
  private boolean trace_enabled = true;

  final public void enable_tracing() {
    trace_enabled = true;
  }

  final public void disable_tracing() {
    trace_enabled = false;
  }

  final private void trace_call(String s) {
    if (trace_enabled) {
      for (int i = 0; i < trace_indent; i++) { System.out.print(" "); }
      System.out.println("Call:   " + s);
    }
    trace_indent = trace_indent + 2;
  }

  final private void trace_return(String s) {
    trace_indent = trace_indent - 2;
    if (trace_enabled) {
      for (int i = 0; i < trace_indent; i++) { System.out.print(" "); }
      System.out.println("Return: " + s);
    }
  }

  final private void trace_token(Token t, String where) {
    if (trace_enabled) {
      for (int i = 0; i < trace_indent; i++) { System.out.print(" "); }
      System.out.print("Consumed token: <" + tokenImage[t.kind]);
      if (t.kind != 0 && !tokenImage[t.kind].equals("\"" + t.image + "\"")) {
        System.out.print(": \"" + t.image + "\"");
      }
      System.out.println(" at line " + t.beginLine + " column " + t.beginColumn + ">" + where);
    }
  }

  final private void trace_scan(Token t1, int t2) {
    if (trace_enabled) {
      for (int i = 0; i < trace_indent; i++) { System.out.print(" "); }
      System.out.print("Visited token: <" + tokenImage[t1.kind]);
      if (t1.kind != 0 && !tokenImage[t1.kind].equals("\"" + t1.image + "\"")) {
        System.out.print(": \"" + t1.image + "\"");
      }
      System.out.println(" at line " + t1.beginLine + " column " + t1.beginColumn + ">; Expected token: <" + tokenImage[t2] + ">");
    }
  }

  final private void jj_rescan_token() {
    jj_rescan = true;
    for (int i = 0; i < 20; i++) {
    try {
      JJCalls p = jj_2_rtns[i];
      do {
        if (p.gen > jj_gen) {
          jj_la = p.arg; jj_lastpos = jj_scanpos = p.first;
          switch (i) {
            case 0: jj_3_1(); break;
            case 1: jj_3_2(); break;
            case 2: jj_3_3(); break;
            case 3: jj_3_4(); break;
            case 4: jj_3_5(); break;
            case 5: jj_3_6(); break;
            case 6: jj_3_7(); break;
            case 7: jj_3_8(); break;
            case 8: jj_3_9(); break;
            case 9: jj_3_10(); break;
            case 10: jj_3_11(); break;
            case 11: jj_3_12(); break;
            case 12: jj_3_13(); break;
            case 13: jj_3_14(); break;
            case 14: jj_3_15(); break;
            case 15: jj_3_16(); break;
            case 16: jj_3_17(); break;
            case 17: jj_3_18(); break;
            case 18: jj_3_19(); break;
            case 19: jj_3_20(); break;
          }
        }
        p = p.next;
      } while (p != null);
      } catch(LookaheadSuccess ls) { }
    }
    jj_rescan = false;
  }

  final private void jj_save(int index, int xla) {
    JJCalls p = jj_2_rtns[index];
    while (p.gen > jj_gen) {
      if (p.next == null) { p = p.next = new JJCalls(); break; }
      p = p.next;
    }
    p.gen = jj_gen + xla - jj_la; p.first = token; p.arg = xla;
  }

  static final class JJCalls {
    int gen;
    Token first;
    int arg;
    JJCalls next;
  }

}
